require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_BITOPS_H)) {
    eval 'sub __ASM_MIPS_BITOPS_H () {1;}' unless defined(&__ASM_MIPS_BITOPS_H);
    require 'linux/types.ph';
    require 'linux/byteorder/swab.ph';
    if(defined(&__KERNEL__)) {
	require 'asm/sgidefs.ph';
	require 'asm/system.ph';
	eval 'sub __bi_flags () {\'unsigned long flags\';}' unless defined(&__bi_flags);
	eval 'sub __bi_cli () {
	    eval q( &__cli());
	}' unless defined(&__bi_cli);
	eval 'sub __bi_save_flags {
	    local($x) = @_;
    	    eval q( &__save_flags($x));
	}' unless defined(&__bi_save_flags);
	eval 'sub __bi_save_and_cli {
	    local($x) = @_;
    	    eval q( &__save_and_cli($x));
	}' unless defined(&__bi_save_and_cli);
	eval 'sub __bi_restore_flags {
	    local($x) = @_;
    	    eval q( &__restore_flags($x));
	}' unless defined(&__bi_restore_flags);
    } else {
	eval 'sub __bi_flags () {1;}' unless defined(&__bi_flags);
	eval 'sub __bi_cli () {
	    eval q();
	}' unless defined(&__bi_cli);
	eval 'sub __bi_save_flags {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&__bi_save_flags);
	eval 'sub __bi_save_and_cli {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&__bi_save_and_cli);
	eval 'sub __bi_restore_flags {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&__bi_restore_flags);
    }
    unless(defined(&__MIPSEB__)) {
    }
    if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	require 'asm/mipsregs.ph';
    } else {
    }
    unless(defined(&__MIPSEB__)) {
	if(((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS2) ? &_MIPS_ISA_MIPS2 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS3) ? &_MIPS_ISA_MIPS3 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS4) ? &_MIPS_ISA_MIPS4 : 0)) || ((defined(&_MIPS_ISA) ? &_MIPS_ISA : 0) == (defined(&_MIPS_ISA_MIPS5) ? &_MIPS_ISA_MIPS5 : 0))) {
	} else {
	}
	if(defined(&__MIPSEB__)) {
	    die("Fix this for big endian");
	}
	if(defined(&__MIPSEB__)) {
	    die("Fix this for big endian byte order");
	}
    }
    if(defined(&__KERNEL__)) {
	eval 'sub ffs {
	    local($x) = @_;
    	    eval q( &generic_ffs($x));
	}' unless defined(&ffs);
	eval 'sub hweight32 {
	    local($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    local($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    local($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
    }
    if(defined(&__MIPSEB__)) {
	eval 'sub find_first_zero_bit {
	    local($addr, $size) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_bit);
    }
    if(defined(&__MIPSEB__)) {
	eval 'sub ext2_find_first_zero_bit {
	    local($addr, $size) = @_;
    	    eval q( &ext2_find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&ext2_find_first_zero_bit);
    } else {
	eval 'sub ext2_set_bit {
	    local($nr, $addr) = @_;
    	    eval q( &test_and_set_bit(($nr), ($addr)));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit {
	    local($nr, $addr) = @_;
    	    eval q( &test_and_clear_bit(($nr), ($addr)));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_test_bit {
	    local($nr, $addr) = @_;
    	    eval q( &test_bit(($nr), ($addr)));
	}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit {
	    local($addr, $size) = @_;
    	    eval q( &find_first_zero_bit(($addr), ($size)));
	}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit {
	    local($addr, $size, $offset) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), ($offset)));
	}' unless defined(&ext2_find_next_zero_bit);
    }
    eval 'sub minix_set_bit {
        local($nr,$addr) = @_;
	    eval q( &test_and_set_bit($nr,$addr));
    }' unless defined(&minix_set_bit);
    eval 'sub minix_clear_bit {
        local($nr,$addr) = @_;
	    eval q( &test_and_clear_bit($nr,$addr));
    }' unless defined(&minix_clear_bit);
    eval 'sub minix_test_bit {
        local($nr,$addr) = @_;
	    eval q( &test_bit($nr,$addr));
    }' unless defined(&minix_test_bit);
    eval 'sub minix_find_first_zero_bit {
        local($addr,$size) = @_;
	    eval q( &find_first_zero_bit($addr,$size));
    }' unless defined(&minix_find_first_zero_bit);
}
1;
