require '_h2ph_pre.ph';

unless(defined(&__ASM_MIPS_UACCESS_H)) {
    eval 'sub __ASM_MIPS_UACCESS_H () {1;}' unless defined(&__ASM_MIPS_UACCESS_H);
    require 'linux/errno.ph';
    require 'linux/sched.ph';
    eval 'sub STR {
        local($x) = @_;
	    eval q( &__STR($x));
    }' unless defined(&STR);
    eval 'sub __STR {
        local($x) = @_;
	    eval q($x);
    }' unless defined(&__STR);
    eval 'sub KERNEL_DS () {(( &mm_segment_t) { 0 });}' unless defined(&KERNEL_DS);
    eval 'sub USER_DS () {(( &mm_segment_t) { 1 });}' unless defined(&USER_DS);
    eval 'sub VERIFY_READ () {0;}' unless defined(&VERIFY_READ);
    eval 'sub VERIFY_WRITE () {1;}' unless defined(&VERIFY_WRITE);
    eval 'sub get_fs () {
        eval q(( ($current->{tss}->{current_ds})));
    }' unless defined(&get_fs);
    eval 'sub get_ds () {
        eval q(( &KERNEL_DS));
    }' unless defined(&get_ds);
    eval 'sub set_fs {
        local($x) = @_;
	    eval q(( ($current->{tss}->{current_ds})=($x)));
    }' unless defined(&set_fs);
    eval 'sub segment_eq {
        local($a,$b) = @_;
	    eval q((($a). &seg == ($b). &seg));
    }' unless defined(&segment_eq);
    eval 'sub __access_ok {
        local($addr,$size,$mask) = @_;
	    eval q((((($mask)($addr | $size | ($addr+$size)))) >= 0));
    }' unless defined(&__access_ok);
    eval 'sub __access_mask () {(-( &get_fs(). &seg));}' unless defined(&__access_mask);
    eval 'sub access_ok {
        local($type,$addr,$size) = @_;
	    eval q( &__access_ok((($addr)),($size), &__access_mask));
    }' unless defined(&access_ok);
    eval 'sub put_user {
        local($x,$ptr) = @_;
	    eval q( &__put_user_check(($x),($ptr),$sizeof{($ptr)}, &__access_mask));
    }' unless defined(&put_user);
    eval 'sub get_user {
        local($x,$ptr) = @_;
	    eval q( &__get_user_check(($x),($ptr),$sizeof{($ptr)}, &__access_mask));
    }' unless defined(&get_user);
    eval 'sub __put_user {
        local($x,$ptr) = @_;
	    eval q( &__put_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__put_user);
    eval 'sub __get_user {
        local($x,$ptr) = @_;
	    eval q( &__get_user_nocheck(($x),($ptr),$sizeof{($ptr)}));
    }' unless defined(&__get_user);
    eval 'sub put_user_ret {
        local($x,$ptr,$ret) = @_;
	    eval q(({  &if ( &put_user($x,$ptr))  &return $ret; }));
    }' unless defined(&put_user_ret);
    eval 'sub get_user_ret {
        local($x,$ptr,$ret) = @_;
	    eval q(({  &if ( &get_user($x,$ptr))  &return $ret; }));
    }' unless defined(&get_user_ret);
    eval 'sub __put_user_ret {
        local($x,$ptr,$ret) = @_;
	    eval q(({  &if ( &__put_user($x,$ptr))  &return $ret; }));
    }' unless defined(&__put_user_ret);
    eval 'sub __get_user_ret {
        local($x,$ptr,$ret) = @_;
	    eval q(({  &if ( &__get_user($x,$ptr))  &return $ret; }));
    }' unless defined(&__get_user_ret);
    eval 'sub __m {
        local($x) = @_;
	    eval q((*($x)));
    }' unless defined(&__m);
    if(defined(&__mips64)) {
	eval 'sub __GET_USER_DW () { &__get_user_asm("ld");}' unless defined(&__GET_USER_DW);
    } else {
	eval 'sub __GET_USER_DW () { &__get_user_asm_ll32;}' unless defined(&__GET_USER_DW);
    }
    eval 'sub __get_user_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __gu_err\';  &__typeof(*)  &__gu_val; \'long __gu_addr\';  &__asm__(\\"\\":\\"=r\\" );  &__gu_addr = ($ptr);  &__asm__(\\"\\":\\"=r\\" ( &__gu_err));  &switch ($size) {  &case 1:  &__get_user_asm(\\"lb\\");  &break;  &case 2:  &__get_user_asm(\\"lh\\");  &break;  &case 4:  &__get_user_asm(\\"lw\\");  &break;  &case 8:  &__GET_USER_DW;  &break;  &default:  &__get_user_unknown();  &break; } $x = ( &__typeof__(*($ptr)))  &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_nocheck);
    eval 'sub __get_user_check {
        local($x,$ptr,$size,$mask) = @_;
	    eval q(({ \'long __gu_err\';  &__typeof__(*)  &__gu_val; \'long __gu_addr\';  &__asm__(\\"\\":\\"=r\\" );  &__gu_addr = ($ptr);  &__asm__(\\"\\":\\"=r\\" ( &__gu_err));  &if ( &__access_ok( &__gu_addr,$size,$mask)) {  &switch ($size) {  &case 1:  &__get_user_asm(\\"lb\\");  &break;  &case 2:  &__get_user_asm(\\"lh\\");  &break;  &case 4:  &__get_user_asm(\\"lw\\");  &break;  &case 8:  &__GET_USER_DW;  &break;  &default:  &__get_user_unknown();  &break; } } $x = ( &__typeof__(*($ptr)))  &__gu_val;  &__gu_err; }));
    }' unless defined(&__get_user_check);
    eval 'sub __get_user_asm {
        local($insn) = @_;
	    eval q(({  &__asm__  &__volatile__( \\"1:\\\\t\\" $insn \\"\\\\t%1,%2\\\\n\\\\t\\" \\"move\\\\t%0,$0\\\\n\\" \\"2:\\\\n\\\\t\\" \\".section\\\\t.fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\tli\\\\t%0,%3\\\\n\\\\t\\" \\"move\\\\t%1,$0\\\\n\\\\t\\" \\"j\\\\t2b\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" \\".section\\\\t__ex_table,\\\\\\"a\\\\\\"\\\\n\\\\t\\" \\".word\\\\t1b,3b\\\\n\\\\t\\" \\".previous\\" :\\"=r\\" ( &__gu_err), \\"=r\\" ( &__gu_val) :\\"o\\" ( &__m( &__gu_addr)), \\"i\\" (- &EFAULT)); }));
    }' unless defined(&__get_user_asm);
    eval 'sub __get_user_asm_ll32 () {({  &__asm__  &__volatile__( "1:\\tlw\\t%1,%2\\n" "2:\\tlw\\t%D1,%3\\n\\t" "move\\t%0,$0\\n" "3:\\t.section\\t.fixup,\\"ax\\"\\n" "4:\\tli\\t%0,%4\\n\\t" "move\\t%1,$0\\n\\t" "move\\t%D1,$0\\n\\t" "j\\t3b\\n\\t" ".previous\\n\\t" ".section\\t__ex_table,\\"a\\"\\n\\t" ".word\\t1b,4b\\n\\t" ".word\\t2b,4b\\n\\t" ".previous" :"=r" ( &__gu_err), "=&r" ( &__gu_val) :"o" ( &__m( &__gu_addr)), "o" ( &__m( &__gu_addr + 4)), "i" (- &EFAULT)); });}' unless defined(&__get_user_asm_ll32);
    if(defined(&__mips64)) {
	eval 'sub __PUT_USER_DW () { &__put_user_asm("sd");}' unless defined(&__PUT_USER_DW);
    } else {
	eval 'sub __PUT_USER_DW () { &__put_user_asm_ll32;}' unless defined(&__PUT_USER_DW);
    }
    eval 'sub __put_user_nocheck {
        local($x,$ptr,$size) = @_;
	    eval q(({ \'long __pu_err\';  &__typeof__(*)  &__pu_val; \'long __pu_addr\';  &__pu_val = ;  &__pu_addr = ($ptr);  &__asm__(\\"\\":\\"=r\\" ( &__pu_err));  &switch ($size) {  &case 1:  &__put_user_asm(\\"sb\\");  &break;  &case 2:  &__put_user_asm(\\"sh\\");  &break;  &case 4:  &__put_user_asm(\\"sw\\");  &break;  &case 8:  &__PUT_USER_DW;  &break;  &default:  &__put_user_unknown();  &break; }  &__pu_err; }));
    }' unless defined(&__put_user_nocheck);
    eval 'sub __put_user_check {
        local($x,$ptr,$size,$mask) = @_;
	    eval q(({ \'long __pu_err\';  &__typeof__(*)  &__pu_val; \'long __pu_addr\';  &__pu_val = ;  &__pu_addr = ($ptr);  &__asm__(\\"\\":\\"=r\\" ( &__pu_err));  &if ( &__access_ok( &__pu_addr,$size,$mask)) {  &switch ($size) {  &case 1:  &__put_user_asm(\\"sb\\");  &break;  &case 2:  &__put_user_asm(\\"sh\\");  &break;  &case 4:  &__put_user_asm(\\"sw\\");  &break;  &case 8:  &__PUT_USER_DW;  &break;  &default:  &__put_user_unknown();  &break; } }  &__pu_err; }));
    }' unless defined(&__put_user_check);
    eval 'sub __put_user_asm {
        local($insn) = @_;
	    eval q(({  &__asm__  &__volatile__( \\"1:\\\\t\\" $insn \\"\\\\t%1,%2\\\\n\\\\t\\" \\"move\\\\t%0,$0\\\\n\\" \\"2:\\\\n\\\\t\\" \\".section\\\\t.fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\tli\\\\t%0,%3\\\\n\\\\t\\" \\"j\\\\t2b\\\\n\\\\t\\" \\".previous\\\\n\\\\t\\" \\".section\\\\t__ex_table,\\\\\\"a\\\\\\"\\\\n\\\\t\\" \\".word\\\\t1b,3b\\\\n\\\\t\\" \\".previous\\" :\\"=r\\" ( &__pu_err) :\\"r\\" ( &__pu_val), \\"o\\" ( &__m( &__pu_addr)), \\"i\\" (- &EFAULT)); }));
    }' unless defined(&__put_user_asm);
    eval 'sub __put_user_asm_ll32 () {({  &__asm__  &__volatile__( "1:\\tsw\\t%1,%2\\n\\t" "2:\\tsw\\t%D1,%3\\n" "move\\t%0,$0\\n" "3:\\n\\t" ".section\\t.fixup,\\"ax\\"\\n" "4:\\tli\\t%0,%4\\n\\t" "j\\t3b\\n\\t" ".previous\\n\\t" ".section\\t__ex_table,\\"a\\"\\n\\t" ".word\\t1b,4b\\n\\t" ".word\\t2b,4b\\n\\t" ".previous" :"=r" ( &__pu_err) :"r" ( &__pu_val), "o" ( &__m( &__pu_addr)), "o" ( &__m( &__pu_addr + 4)), "i" (- &EFAULT)); });}' unless defined(&__put_user_asm_ll32);
    if(defined(&MODULE)) {
	eval 'sub __MODULE_JAL {
	    local($destination) = @_;
    	    eval q(\\".set\\\\tnoat\\\\n\\\\t\\" \\"la\\\\t$1, \\" $destination \\"\\\\n\\\\t\\" \\"jalr\\\\t$1\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\");
	}' unless defined(&__MODULE_JAL);
    } else {
	eval 'sub __MODULE_JAL {
	    local($destination) = @_;
    	    eval q(\\"jal\\\\t\\" $destination \\"\\\\n\\\\t\\");
	}' unless defined(&__MODULE_JAL);
    }
    eval 'sub copy_to_user_ret {
        local($to,$from,$n,$retval) = @_;
	    eval q(({  &if ( &copy_to_user($to,$from,$n))  &return $retval; }));
    }' unless defined(&copy_to_user_ret);
    eval 'sub copy_from_user_ret {
        local($to,$from,$n,$retval) = @_;
	    eval q(({  &if ( &copy_from_user($to,$from,$n))  &return $retval; }));
    }' unless defined(&copy_from_user_ret);
    eval 'sub __copy_to_user {
        local($to,$from,$n) = @_;
	    eval q(({  &void * &__cu_to;  &const  &void * &__cu_from; \'long __cu_len\';  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &__asm__  &__volatile__( \\"move\\\\t$4, %1\\\\n\\\\t\\" \\"move\\\\t$5, %2\\\\n\\\\t\\" \\"move\\\\t$6, %3\\\\n\\\\t\\"  &__MODULE_JAL( &__copy_user) \\"move\\\\t%0, $6\\" : \\"=r\\" ( &__cu_len) : \\"r\\" ( &__cu_to), \\"r\\" ( &__cu_from), \\"r\\" ( &__cu_len) : \\"$4\\", \\"$5\\", \\"$6\\", \\"$8\\", \\"$9\\", \\"$10\\", \\"$11\\", \\"$12\\", \\"$15\\", \\"$24\\", \\"$31\\",\\"memory\\");  &__cu_len; }));
    }' unless defined(&__copy_to_user);
    eval 'sub __copy_from_user {
        local($to,$from,$n) = @_;
	    eval q(({  &void * &__cu_to;  &const  &void * &__cu_from; \'long __cu_len\';  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &__asm__  &__volatile__( \\"move\\\\t$4, %1\\\\n\\\\t\\" \\"move\\\\t$5, %2\\\\n\\\\t\\" \\"move\\\\t$6, %3\\\\n\\\\t\\" \\".set\\\\tnoat\\\\n\\\\t\\" \\"addu\\\\t$1, %2, %3\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\"  &__MODULE_JAL( &__copy_user) \\"move\\\\t%0, $6\\" : \\"=r\\" ( &__cu_len) : \\"r\\" ( &__cu_to), \\"r\\" ( &__cu_from), \\"r\\" ( &__cu_len) : \\"$4\\", \\"$5\\", \\"$6\\", \\"$8\\", \\"$9\\", \\"$10\\", \\"$11\\", \\"$12\\", \\"$15\\", \\"$24\\", \\"$31\\",\\"memory\\");  &__cu_len; }));
    }' unless defined(&__copy_from_user);
    eval 'sub copy_to_user {
        local($to,$from,$n) = @_;
	    eval q(({  &void * &__cu_to;  &const  &void * &__cu_from; \'long __cu_len\';  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &if ( &access_ok( &VERIFY_WRITE,  &__cu_to,  &__cu_len))  &__asm__  &__volatile__( \\"move\\\\t$4, %1\\\\n\\\\t\\" \\"move\\\\t$5, %2\\\\n\\\\t\\" \\"move\\\\t$6, %3\\\\n\\\\t\\"  &__MODULE_JAL( &__copy_user) \\"move\\\\t%0, $6\\" : \\"=r\\" ( &__cu_len) : \\"r\\" ( &__cu_to), \\"r\\" ( &__cu_from), \\"r\\" ( &__cu_len) : \\"$4\\", \\"$5\\", \\"$6\\", \\"$8\\", \\"$9\\", \\"$10\\", \\"$11\\", \\"$12\\", \\"$15\\", \\"$24\\", \\"$31\\",\\"memory\\");  &__cu_len; }));
    }' unless defined(&copy_to_user);
    eval 'sub copy_from_user {
        local($to,$from,$n) = @_;
	    eval q(({  &void * &__cu_to;  &const  &void * &__cu_from; \'long __cu_len\';  &__cu_to = ($to);  &__cu_from = ($from);  &__cu_len = ($n);  &if ( &access_ok( &VERIFY_READ,  &__cu_from,  &__cu_len))  &__asm__  &__volatile__( \\"move\\\\t$4, %1\\\\n\\\\t\\" \\"move\\\\t$5, %2\\\\n\\\\t\\" \\"move\\\\t$6, %3\\\\n\\\\t\\" \\".set\\\\tnoat\\\\n\\\\t\\" \\"addu\\\\t$1, %2, %3\\\\n\\\\t\\" \\".set\\\\tat\\\\n\\\\t\\"  &__MODULE_JAL( &__copy_user) \\"move\\\\t%0, $6\\" : \\"=r\\" ( &__cu_len) : \\"r\\" ( &__cu_to), \\"r\\" ( &__cu_from), \\"r\\" ( &__cu_len) : \\"$4\\", \\"$5\\", \\"$6\\", \\"$8\\", \\"$9\\", \\"$10\\", \\"$11\\", \\"$12\\", \\"$15\\", \\"$24\\", \\"$31\\",\\"memory\\");  &__cu_len; }));
    }' unless defined(&copy_from_user);
    eval 'sub clear_user {
        local($addr,$n) = @_;
	    eval q(({  &void *  &__cl_addr = ; \'unsigned long __cl_size\' = ;  &if ( &__cl_size  &&  &__access_ok( &VERIFY_WRITE, (( &__cl_addr)),  &__cl_size))  &__cl_size =  &__clear_user( &__cl_addr,  &__cl_size);  &__cl_size; }));
    }' unless defined(&clear_user);
    eval 'sub fixup_exception {
        local($map_reg, $fixup_unit, $pc) = @_;
	    eval q(({ $fixup_unit; }));
    }' unless defined(&fixup_exception);
}
1;
